Index: de1/COPYRIGHT_NOTICE
===================================================================
--- de1/COPYRIGHT_NOTICE	(revision 23)
+++ de1/COPYRIGHT_NOTICE	(revision 24)
@@ -70,7 +70,6 @@
 Parameters modified for my use case
 
 i2c_loader.vhd
-i2s_intf.vhd
 
 -----------------------------------------------------------------------------------
 (c) Peter Wendrich
Index: de1/atari800core.qsf
===================================================================
--- de1/atari800core.qsf	(revision 23)
+++ de1/atari800core.qsf	(revision 24)
@@ -38,7 +38,7 @@
 
 set_global_assignment -name FAMILY "Cyclone II"
 set_global_assignment -name DEVICE EP2C20F484C7
-set_global_assignment -name TOP_LEVEL_ENTITY atari800core
+set_global_assignment -name TOP_LEVEL_ENTITY atari800core_de1
 set_global_assignment -name ORIGINAL_QUARTUS_VERSION "12.1 SP1"
 set_global_assignment -name PROJECT_CREATION_TIME_DATE "13:58:39  APRIL 11, 2013"
 set_global_assignment -name LAST_QUARTUS_VERSION "12.1 SP1.33"
@@ -555,64 +555,6 @@
 set_global_assignment -name AUTO_PACKED_REGISTERS_STRATIXII NORMAL
 set_global_assignment -name FITTER_EFFORT "AUTO FIT"
 set_global_assignment -name OPTIMIZE_HOLD_TIMING "ALL PATHS"
-set_global_assignment -name VHDL_FILE atari800core.vhd
-set_global_assignment -name VHDL_FILE spi_master.vhd
-set_global_assignment -name VHDL_FILE zpu_config_regs.vhdl
-set_global_assignment -name VHDL_FILE zpu_rom.vhd
-set_global_assignment -name SOURCE_FILE zpu_rom.cmp
-set_global_assignment -name VHDL_FILE zpu_core.vhd
-set_global_assignment -name VHDL_FILE zpupkg.vhd
-set_global_assignment -name VHDL_FILE sdram_statemachine.vhdl
-set_global_assignment -name VHDL_FILE cpu_65xx_e.vhd
-set_global_assignment -name VHDL_FILE cpu_65xx_a.vhd
-set_global_assignment -name VHDL_FILE i2s_intf.vhd
-set_global_assignment -name VHDL_FILE i2c_loader.vhd
-set_global_assignment -name VHDL_FILE cpu.vhd
-set_global_assignment -name VHDL_FILE ledsw.vhd
-set_global_assignment -name VHDL_FILE hexdecoder.vhd
-set_global_assignment -name QIP_FILE pll.qip
-set_global_assignment -name SDC_FILE atari800core.sdc
-set_global_assignment -name VHDL_FILE dumprom.vhdl
-set_global_assignment -name VHDL_FILE reg_file.vhdl
-set_global_assignment -name VHDL_FILE address_decoder.vhdl
-set_global_assignment -name VHDL_FILE i2sslave.vhdl
-set_global_assignment -name VHDL_FILE pokey.vhdl
-set_global_assignment -name VHDL_FILE nmigen.vhdl
-set_global_assignment -name VHDL_FILE enable_divider.vhdl
-set_global_assignment -name VHDL_FILE poly_17_9.vhdl
-set_global_assignment -name VHDL_FILE poly_5.vhdl
-set_global_assignment -name VHDL_FILE poly_4.vhdl
-set_global_assignment -name VHDL_FILE delay_line.vhdl
-set_global_assignment -name VHDL_FILE countdown_timer.vhdl
-set_global_assignment -name VHDL_FILE pokey_mixer.vhdl
-set_global_assignment -name VHDL_FILE pokey_noise_filter.vhdl
-set_global_assignment -name VHDL_FILE complete_address_decoder.vhdl
-set_global_assignment -name VHDL_FILE tvsync.vhdl
-set_global_assignment -name VHDL_FILE ps2_keyboard.vhdl
-set_global_assignment -name VHDL_FILE pokey_ps2_decoder.vhdl
-set_global_assignment -name VHDL_FILE flashrom.vhdl
-set_global_assignment -name VHDL_FILE sram.vhdl
-set_global_assignment -name VHDL_FILE antic.vhdl
-set_global_assignment -name VHDL_FILE antic_dma_clock.vhdl
-set_global_assignment -name VHDL_FILE antic_counter.vhdl
-set_global_assignment -name VHDL_FILE simple_counter.vhdl
-set_global_assignment -name VHDL_FILE gtia.vhdl
-set_global_assignment -name VHDL_FILE gtia_palette.vhdl
-set_global_assignment -name VHDL_FILE pia.vhdl
-set_global_assignment -name VHDL_FILE shared_enable.vhdl
-set_global_assignment -name VHDL_FILE gtia_player.vhdl
-set_global_assignment -name VHDL_FILE gtia_priority.vhdl
-set_global_assignment -name VHDL_FILE synchronizer.vhdl
-set_global_assignment -name VHDL_FILE scandoubler.vhdl
-set_global_assignment -name VHDL_FILE scandouble_ram_infer.vhdl
-set_global_assignment -name VHDL_FILE syncreset_enable_divider.vhd
-set_global_assignment -name VHDL_FILE wide_delay_line.vhdl
-set_global_assignment -name VHDL_FILE irq_glue.vhdl
-set_global_assignment -name VHDL_FILE gpio.vhd
-set_global_assignment -name VHDL_FILE pokey_keyboard_scanner.vhdl
-set_global_assignment -name VHDL_FILE zpu_glue.vhdl
-set_global_assignment -name QIP_FILE zpu_ram.qip
-set_global_assignment -name QIP_FILE zpu_rom.qip
 set_location_assignment PIN_A13 -to GPIO_0[0]
 set_location_assignment PIN_B13 -to GPIO_0[1]
 set_location_assignment PIN_A14 -to GPIO_0[2]
@@ -621,6 +563,14 @@
 set_global_assignment -name USE_SIGNALTAP_FILE output_files/stp1.stp
 set_global_assignment -name SIGNALTAP_FILE output_files/stp1.stp
 
+set_instance_assignment -name PARTITION_HIERARCHY root_partition -to | -section_id Top
 
+set_global_assignment -name VHDL_FILE atari800core_de1.vhd
+set_global_assignment -name VHDL_FILE hexdecoder.vhd
+set_global_assignment -name VHDL_FILE i2c_loader.vhd
+set_global_assignment -name VHDL_FILE i2s_intf.vhd
+set_global_assignment -name VHDL_FILE i2sslave.vhdl
+set_global_assignment -name QIP_FILE pll.qip
+set_global_assignment -name VHDL_FILE sram.vhdl
+set_global_assignment -name VHDL_FILE sync_switches.vhd
 
-set_instance_assignment -name PARTITION_HIERARCHY root_partition -to | -section_id Top
\ No newline at end of file
Index: de1/atari800core_de1.vhd
===================================================================
--- de1/atari800core_de1.vhd	(nonexistent)
+++ de1/atari800core_de1.vhd	(revision 24)
@@ -0,0 +1,534 @@
+---------------------------------------------------------------------------
+-- (c) 2013 mark watson
+-- I am happy for anyone to use this for non-commercial use.
+-- If my vhdl files are used commercially or otherwise sold,
+-- please contact me for explicit permission at scrameta (gmail).
+-- This applies for source and binary form and derived works.
+---------------------------------------------------------------------------
+
+LIBRARY ieee;
+USE ieee.std_logic_1164.all; 
+use ieee.numeric_std.all;
+
+LIBRARY work;
+
+ENTITY atari800core_de1 IS 
+	PORT
+	(
+		CLOCK_50 :  IN  STD_LOGIC;
+
+		AUD_BCLK :  IN  STD_LOGIC;
+		AUD_DACLRCK :  IN  STD_LOGIC;
+		I2C_SCLK :  INOUT  STD_LOGIC;
+		I2C_SDAT :  INOUT  STD_LOGIC;
+
+		PS2_CLK :  IN  STD_LOGIC;
+		PS2_DAT :  IN  STD_LOGIC;
+
+		UART_RXD :  IN  STD_LOGIC;
+		UART_TXD :  OUT  STD_LOGIC;
+
+		GPIO_0 :  INOUT  STD_LOGIC_VECTOR(35 DOWNTO 0);
+		GPIO_1 :  INOUT  STD_LOGIC_VECTOR(35 DOWNTO 0);
+
+		KEY :  IN  STD_LOGIC_VECTOR(3 DOWNTO 0);
+		SW :  IN  STD_LOGIC_VECTOR(9 DOWNTO 0);
+
+		AUD_XCK :  OUT  STD_LOGIC;
+		AUD_DACDAT :  OUT  STD_LOGIC;
+
+		FL_OE_N :  OUT  STD_LOGIC;
+		FL_WE_N :  OUT  STD_LOGIC;
+		FL_RST_N :  OUT  STD_LOGIC;
+		FL_ADDR :  OUT  STD_LOGIC_VECTOR(21 DOWNTO 0);
+		FL_DQ :  IN  STD_LOGIC_VECTOR(7 DOWNTO 0);
+
+		SRAM_CE_N :  OUT  STD_LOGIC;
+		SRAM_OE_N :  OUT  STD_LOGIC;
+		SRAM_WE_N :  OUT  STD_LOGIC;
+		SRAM_LB_N :  OUT  STD_LOGIC;
+		SRAM_UB_N :  OUT  STD_LOGIC;
+		SRAM_ADDR :  OUT  STD_LOGIC_VECTOR(17 DOWNTO 0);
+		SRAM_DQ :  INOUT  STD_LOGIC_VECTOR(15 DOWNTO 0);
+
+		DRAM_BA_0 :  OUT  STD_LOGIC;
+		DRAM_BA_1 :  OUT  STD_LOGIC;
+		DRAM_CS_N :  OUT  STD_LOGIC;
+		DRAM_RAS_N :  OUT  STD_LOGIC;
+		DRAM_CAS_N :  OUT  STD_LOGIC;
+		DRAM_WE_N :  OUT  STD_LOGIC;
+		DRAM_LDQM :  OUT  STD_LOGIC;
+		DRAM_UDQM :  OUT  STD_LOGIC;
+		DRAM_CLK :  OUT  STD_LOGIC;
+		DRAM_CKE :  OUT  STD_LOGIC;
+		DRAM_ADDR :  OUT  STD_LOGIC_VECTOR(11 DOWNTO 0);
+		DRAM_DQ :  INOUT  STD_LOGIC_VECTOR(15 DOWNTO 0);
+
+		SD_CLK :  OUT  STD_LOGIC;
+		SD_CMD :  OUT  STD_LOGIC;
+		SD_THREE :  OUT  STD_LOGIC;
+		SD_DATA :  IN  STD_LOGIC;
+
+		HEX0 :  OUT  STD_LOGIC_VECTOR(6 DOWNTO 0);
+		HEX1 :  OUT  STD_LOGIC_VECTOR(6 DOWNTO 0);
+		HEX2 :  OUT  STD_LOGIC_VECTOR(6 DOWNTO 0);
+		HEX3 :  OUT  STD_LOGIC_VECTOR(6 DOWNTO 0);
+
+		LEDG :  OUT  STD_LOGIC_VECTOR(7 DOWNTO 0);
+		LEDR :  OUT  STD_LOGIC_VECTOR(9 DOWNTO 0);
+
+		VGA_VS :  OUT  STD_LOGIC;
+		VGA_HS :  OUT  STD_LOGIC;
+		VGA_B :  OUT  STD_LOGIC_VECTOR(3 DOWNTO 0);
+		VGA_G :  OUT  STD_LOGIC_VECTOR(3 DOWNTO 0);
+		VGA_R :  OUT  STD_LOGIC_VECTOR(3 DOWNTO 0)
+	);
+END atari800core_de1;
+
+ARCHITECTURE vhdl OF atari800core_de1 IS 
+	-- SYSTEM
+	SIGNAL CLK : STD_LOGIC;
+	SIGNAL CLK_SDRAM : STD_LOGIC;
+	SIGNAL RESET_N : STD_LOGIC;
+	SIGNAL PLL_LOCKED : STD_LOGIC;
+
+	-- PIA
+	SIGNAL	CA1_IN :  STD_LOGIC;
+	SIGNAL	CB1_IN:  STD_LOGIC;
+	SIGNAL	CA2_OUT :  STD_LOGIC;
+	SIGNAL	CA2_DIR_OUT:  STD_LOGIC;
+	SIGNAL	CB2_OUT :  STD_LOGIC;
+	SIGNAL	CB2_DIR_OUT:  STD_LOGIC;
+	SIGNAL	CA2_IN:  STD_LOGIC;
+	SIGNAL	CB2_IN:  STD_LOGIC;
+	SIGNAL	PORTA_IN :  STD_LOGIC_VECTOR(7 DOWNTO 0);
+	SIGNAL	PORTA_OUT :  STD_LOGIC_VECTOR(7 DOWNTO 0);
+	SIGNAL	PORTA_DIR_OUT :  STD_LOGIC_VECTOR(7 DOWNTO 0);
+	SIGNAL	PORTB_IN :  STD_LOGIC_VECTOR(7 DOWNTO 0);
+	SIGNAL	PORTB_OUT :  STD_LOGIC_VECTOR(7 DOWNTO 0);
+	--SIGNAL	PORTB_DIR_OUT :  STD_LOGIC_VECTOR(7 DOWNTO 0);
+	
+	-- GTIA
+	signal GTIA_TRIG : std_logic_vector(3 downto 0);
+	
+	-- ANTIC
+	signal ANTIC_LIGHTPEN : std_logic;
+	
+	-- CARTRIDGE ACCESS
+	SIGNAL	CART_RD4 :  STD_LOGIC;
+	SIGNAL	CART_RD5 :  STD_LOGIC;
+	
+	-- PBI
+	SIGNAL PBI_WRITE_DATA : std_logic_vector(31 downto 0);
+	SIGNAL PBI_WIDTH_32BIT_ACCESS : std_logic;
+	SIGNAL PBI_WIDTH_16BIT_ACCESS : std_logic;
+	SIGNAL PBI_WIDTH_8BIT_ACCESS : std_logic;
+	
+	-- INTERNAL ROM/RAM
+	SIGNAL	RAM_ADDR :  STD_LOGIC_VECTOR(18 DOWNTO 0);
+	SIGNAL	RAM_DO :  STD_LOGIC_VECTOR(15 DOWNTO 0);
+	SIGNAL	RAM_REQUEST :  STD_LOGIC;
+	SIGNAL	RAM_REQUEST_COMPLETE :  STD_LOGIC;
+	SIGNAL	RAM_WRITE_ENABLE :  STD_LOGIC;
+	
+	SIGNAL	ROM_ADDR :  STD_LOGIC_VECTOR(21 DOWNTO 0);
+	SIGNAL	ROM_DO :  STD_LOGIC_VECTOR(7 DOWNTO 0);
+	SIGNAL	ROM_REQUEST :  STD_LOGIC;
+	SIGNAL	ROM_REQUEST_COMPLETE :  STD_LOGIC;
+
+	-- pokey keyboard
+	SIGNAL KEYBOARD_SCAN : std_logic_vector(5 downto 0);
+	SIGNAL KEYBOARD_RESPONSE : std_logic_vector(1 downto 0);
+	
+	-- gtia consol keys
+	SIGNAL CONSOL_START : std_logic;
+	SIGNAL CONSOL_SELECT : std_logic;
+	SIGNAL CONSOL_OPTION : std_logic;
+	
+	-- 6502 throttling
+	SIGNAL THROTTLE_COUNT_6502 : std_logic_vector(5 downto 0);
+
+	-- SIO
+	SIGNAL SIO_RXD : std_logic;
+	SIGNAL SIO_COMMAND : std_logic;
+	SIGNAL SIO_TXD : std_logic;
+
+	-- VIDEO
+	signal VGA_VS_RAW : std_logic;
+	signal VGA_HS_RAW : std_logic;
+
+	-- AUDIO
+	signal AUDIO_LEFT : std_logic_vector(15 downto 0);
+	signal AUDIO_RIGHT : std_logic_vector(15 downto 0);
+
+BEGIN 
+
+-- ANYTHING NOT CONNECTED...
+GPIO_0(0) <= 'Z';
+GPIO_0(35 downto 2) <= (others=>'Z');
+GPIO_1(35 downto 0) <= (others=>'Z');
+
+FL_OE_N <= '1';
+FL_WE_N <= '1';
+FL_RST_N <= '1';
+FL_ADDR <= (others=>'0');
+
+DRAM_BA_0 <= '1';
+DRAM_BA_1 <= '1';
+DRAM_CS_N <= '1';
+DRAM_RAS_N <= '1';
+DRAM_CAS_N <= '1';
+DRAM_WE_N <= '1';
+DRAM_LDQM <= '1';
+DRAM_UDQM <= '1';
+DRAM_CKE <= '0';
+DRAM_ADDR <= (others=>'0');
+DRAM_DQ <= (others=>'Z');
+
+SD_CLK <= '1';
+SD_CMD <= '1';
+SD_THREE <= '1';
+
+LEDG <= (others=>'1');
+LEDR <= (others=>'1');
+
+-- TODO FUJI? Or Program counter or...
+hexdecoder0 : entity work.hexdecoder
+PORT MAP(CLK => CLK,
+		 NUMBER => X"A",
+		 DIGIT => HEX0);
+
+
+hexdecoder1 : entity work.hexdecoder
+PORT MAP(CLK => CLK,
+		 NUMBER => X"7",
+		 DIGIT => HEX1);
+
+
+hexdecoder2 : entity work.hexdecoder
+PORT MAP(CLK => CLK,
+		 NUMBER => X"A",
+		 DIGIT => HEX2);
+
+
+hexdecoder3 : entity work.hexdecoder
+PORT MAP(CLK => CLK,
+		 NUMBER => X"1",
+		 DIGIT => HEX3);
+
+sram1 : entity work.sram
+PORT MAP(WREN => RAM_WRITE_ENABLE,
+		 clk => CLK,
+		 reset_n => RESET_N,
+		 request => RAM_REQUEST,
+		 width_16bit => PBI_WIDTH_16BIT_ACCESS,
+		 ADDRESS => RAM_ADDR,
+		 DIN => PBI_WRITE_DATA(15 DOWNTO 0),
+		 SRAM_DQ => SRAM_DQ,
+		 SRAM_CE_N => SRAM_CE_N,
+		 SRAM_OE_N => SRAM_OE_N,
+		 SRAM_WE_N => SRAM_WE_N,
+		 SRAM_LB_N => SRAM_LB_N,
+		 SRAM_UB_N => SRAM_UB_N,
+		 complete => RAM_REQUEST_COMPLETE,
+		 DOUT => RAM_DO,
+		 SRAM_ADDR => SRAM_ADDR);
+
+-- PIA mapping
+CA1_IN <= '1';
+CB1_IN <= '1';
+CA2_IN <= CA2_OUT when CA2_DIR_OUT='1' else '1';
+CB2_IN <= CB2_OUT when CB2_DIR_OUT='1' else '1';
+SIO_COMMAND <= CB2_OUT;
+--PORTA_IN <= ((JOY2_n(3)&JOY2_n(2)&JOY2_n(1)&JOY2_n(0)&JOY1_n(3)&JOY1_n(2)&JOY1_n(1)&JOY1_n(0)) and not (porta_dir_out)) or (porta_dir_out and porta_out);
+PORTA_IN <= (not (porta_dir_out)) or (porta_dir_out and porta_out);
+PORTB_IN <= PORTB_OUT;
+
+-- ANTIC lightpen
+ANTIC_LIGHTPEN <= '1'; --JOY2_n(4) and JOY1_n(4);
+
+-- GTIA triggers
+--GTIA_TRIG <= CART_RD5&"1"&JOY2_n(4)&JOY1_n(4);
+GTIA_TRIG <= CART_RD5&"111";
+
+-- Cartridge not inserted
+CART_RD4 <= '0';
+CART_RD5 <= '0';
+
+-- Since we're not exposing PBI, expose a few key parts needed for SDRAM
+--SDRAM_DI <= PBI_WRITE_DATA;
+
+-- Internal rom/ram
+internalromram1 : entity work.internalromram
+	GENERIC MAP
+	(
+		internal_rom => 1,
+		internal_ram => 0
+	)
+	PORT MAP (
+ 		clock   => CLK,
+		reset_n => RESET_N,
+
+		ROM_ADDR => ROM_ADDR,
+		ROM_REQUEST_COMPLETE => ROM_REQUEST_COMPLETE,
+		ROM_REQUEST => ROM_REQUEST,
+		ROM_DATA => ROM_DO,
+		
+		RAM_ADDR => RAM_ADDR,
+		RAM_WR_ENABLE => RAM_WRITE_ENABLE,
+		RAM_DATA_IN => PBI_WRITE_DATA(7 downto 0),
+		RAM_REQUEST_COMPLETE => open,
+		RAM_REQUEST => RAM_REQUEST,
+		RAM_DATA => open
+	);
+
+--sync_switches1 : entity work.sync_switches
+--PORT MAP(CLK => CLK,
+--		 KEY => KEY,
+--		 SW => SW,
+--		 SYNC_KEYS => SYNC_KEYS,
+--		 SYNC_SWITCHES => SYNC_SWITCHES);
+
+--gpio0_gen:
+--   for I in 0 to 35 generate
+--		gpio_0(I) <= gpio_0_out(I) when gpio_0_dir_out(I)='1' else 'Z';
+--   end generate gpio0_gen;
+--
+--gpio1_gen:
+--   for I in 0 to 35 generate
+--		gpio_1(I) <= gpio_1_out(I) when gpio_1_dir_out(I)='1' else 'Z';
+--   end generate gpio1_gen;
+	
+--b2v_inst19 : entity work.gpio
+--PORT MAP(clk => CLK,
+--		 gpio_enable => GPIO_ENABLE,
+--		 pot_reset => POT_RESET,
+--		 virtual_keyheld => KEY_HELD,
+--		 virtual_shift_pressed => SHIFT_PRESSED,
+--		 virtual_control_pressed => KBCODE(7),
+--		 virtual_break_pressed => BREAK_PRESSED,
+--		 pbi_write_enable => PBI_WRITE_ENABLE,
+--		 cart_request => CART_REQUEST,
+--		 s4_n => CART_S4_n,
+--		 s5_n => CART_S5_N,
+--		 cctl_n => CART_CCTL_N,
+--		 cart_data_write => WRITE_DATA(7 DOWNTO 0),
+--		 GPIO_0_IN => GPIO_0,
+--		 GPIO_0_OUT => GPIO_0_OUT,
+--		 GPIO_0_DIR_OUT => GPIO_0_DIR_OUT,
+--		 GPIO_1_IN => GPIO_1,
+--		 GPIO_1_OUT => GPIO_1_OUT,
+--		 GPIO_1_DIR_OUT => GPIO_1_DIR_OUT,		 
+--		 keyboard_scan => KEYBOARD_SCAN,
+--		 pbi_addr_out => PBI_ADDR,
+--		 porta_out => PORTA_OUT,
+--		 porta_output => PORTA_DIR_OUT,
+--		 virtual_keycode => KBCODE(5 DOWNTO 0),
+--		 virtual_stick_in => VIRTUAL_STICKS,
+--		 virtual_trig_in => VIRTUAL_TRIGGERS,
+--		 lightpen => LIGHTPEN,
+--		 cart_complete => CART_REQUEST_COMPLETE,
+--		 rd4 => CART_RD4,
+--		 rd5 => CART_RD5,
+--		 cart_data_read => CART_ROM_DO,
+--		 keyboard_response => KEYBOARD_RESPONSE,
+--		 porta_in => GPIO_PORTA_IN,
+--		 pot_in => POT_IN,
+--		 trig_in => TRIGGERS,
+--		 monitor => SIO_DATA_IN, -- i.e. zpu sio out
+--		 CA2_DIR_OUT => CA2_DIR_OUT,
+--		 CA2_OUT => CA2_OUT,
+--		 CA2_IN => GPIO_CA2_IN,
+--		 CB2_DIR_OUT => CB2_DIR_OUT,
+--		 CB2_OUT => CB2_OUT,
+--		 CB2_IN => GPIO_CB2_IN,
+--		 SIO_IN => GPIO_SIO_IN,
+--		 SIO_OUT => GPIO_SIO_OUT
+--		 );
+
+--b2v_inst22 : entity work.scandoubler
+--PORT MAP(CLK => CLK,
+--		 RESET_N => RESET_N,
+--		 VGA => VGA,
+--		 COMPOSITE_ON_HSYNC => COMPOSITE_ON_HSYNC,
+--		 colour_enable => SCANDOUBLER_SHARED_ENABLE_LOW,
+--		 doubled_enable => SCANDOUBLER_SHARED_ENABLE_HIGH,
+--		 vsync_in => SYNTHESIZED_WIRE_12,
+--		 hsync_in => SYNTHESIZED_WIRE_13,
+--		 colour_in => SYNTHESIZED_WIRE_14,
+--		 VSYNC => VGA_VS,
+--		 HSYNC => VGA_HS,
+--		 B => VGA_B,
+--		 G => VGA_G,
+--		 R => VGA_R);
+
+
+audio_codec_config_over_i2c : entity work.i2c_loader
+GENERIC MAP(device_address => 26,
+			log2_divider => 6,
+			num_retries => 0
+			)
+PORT MAP(CLK => CLK,
+		 nRESET => RESET_N,
+		 I2C_SCL => I2C_SCLK,
+		 I2C_SDA => I2C_SDAT);
+
+audio_codec_data : entity work.i2sslave
+PORT MAP(CLK => CLK,
+		 BCLK => AUD_BCLK,
+		 DACLRC => AUD_DACLRCK,
+		 LEFT_IN => AUDIO_LEFT,
+		 RIGHT_IN => AUDIO_RIGHT,
+		 MCLK_2 => AUD_XCK,
+		 DACDAT => AUD_DACDAT);
+
+pll : entity work.pll
+PORT MAP(inclk0 => CLOCK_50,
+		 c0 => CLK_SDRAM,
+		 c1 => CLK,
+		 c2 => DRAM_CLK,
+		 locked => PLL_LOCKED);
+
+RESET_N <= PLL_LOCKED;
+
+-- PS2 to pokey
+keyboard_map1 : entity work.ps2_to_atari800
+	PORT MAP
+	( 
+		CLK => clk,
+		RESET_N => reset_n,
+		PS2_CLK => ps2_clk,
+		PS2_DAT => ps2_dat,
+		
+		KEYBOARD_SCAN => KEYBOARD_SCAN,
+		KEYBOARD_RESPONSE => KEYBOARD_RESPONSE,
+
+		CONSOL_START => CONSOL_START,
+		CONSOL_SELECT => CONSOL_SELECT,
+		CONSOL_OPTION => CONSOL_OPTION
+		
+		-- TODO - reset!
+	);
+
+-- SIO
+SIO_RXD <= UART_RXD;
+UART_TXD <= SIO_TXD;
+GPIO_0(1) <= SIO_COMMAND;
+
+-- THROTTLE
+THROTTLE_COUNT_6502 <= std_logic_vector(to_unsigned(32-1,6));
+
+-- VIDEO
+VGA_HS <= not(VGA_HS_RAW xor VGA_VS_RAW);
+VGA_VS <= not(VGA_VS_RAW);
+
+atari800 : entity work.atari800core
+	GENERIC MAP
+	(
+		cycle_length => 32,
+		video_bits => 4
+	)
+	PORT MAP
+	(
+		CLK => CLK,
+		RESET_N => RESET_N,
+
+		VGA_VS => VGA_VS_RAW,
+		VGA_HS => VGA_HS_RAW,
+		VGA_B => VGA_B,
+		VGA_G => VGA_G,
+		VGA_R => VGA_R,
+
+		AUDIO_L => AUDIO_LEFT,
+		AUDIO_R => AUDIO_RIGHT,
+
+		CA1_IN => CA1_IN,
+		CB1_IN => CB1_IN,
+		CA2_IN => CA2_IN,
+		CA2_OUT => CA2_OUT,
+		CA2_DIR_OUT => CA2_DIR_OUT,
+		CB2_IN => CB2_IN,
+		CB2_OUT => CB2_OUT,
+		CB2_DIR_OUT => CB2_DIR_OUT,
+		PORTA_IN => PORTA_IN,
+		PORTA_DIR_OUT => PORTA_DIR_OUT,
+		PORTA_OUT => PORTA_OUT,
+		PORTB_IN => PORTB_IN,
+		PORTB_DIR_OUT => open,--PORTB_DIR_OUT,
+		PORTB_OUT => PORTB_OUT,
+
+		KEYBOARD_RESPONSE => KEYBOARD_RESPONSE,
+		KEYBOARD_SCAN => KEYBOARD_SCAN,
+
+		POT_IN => "00000000",
+		POT_RESET => open,
+		
+		PBI_ADDR => open,
+		PBI_WRITE_ENABLE => open,
+		PBI_SNOOP_DATA => open,
+		PBI_WRITE_DATA => PBI_WRITE_DATA,
+		PBI_WIDTH_8bit_ACCESS => PBI_WIDTH_8bit_ACCESS,
+		PBI_WIDTH_16bit_ACCESS => PBI_WIDTH_16bit_ACCESS,
+		PBI_WIDTH_32bit_ACCESS => PBI_WIDTH_32bit_ACCESS,
+
+		PBI_ROM_DO => "11111111",
+		PBI_REQUEST => open,
+		PBI_REQUEST_COMPLETE => '1',
+
+		CART_RD4 => CART_RD4,
+		CART_RD5 => CART_RD5,
+		CART_S4_n => open,
+		CART_S5_N => open,
+		CART_CCTL_N => open,
+
+		SIO_RXD => SIO_RXD,
+		SIO_TXD => SIO_TXD,
+
+		CONSOL_OPTION => CONSOL_OPTION,
+		CONSOL_SELECT => CONSOL_SELECT,
+		CONSOL_START=> CONSOL_START,
+		GTIA_TRIG => GTIA_TRIG,
+		
+		ANTIC_LIGHTPEN => ANTIC_LIGHTPEN,
+
+		SDRAM_REQUEST => open,
+		SDRAM_REQUEST_COMPLETE => '0',
+		SDRAM_READ_ENABLE => open,
+		SDRAM_WRITE_ENABLE => open,
+		SDRAM_ADDR => open,
+		SDRAM_DO => (others=>'0'),
+
+		SDRAM_REFRESH => open, -- TODO
+
+		RAM_ADDR => RAM_ADDR,
+		RAM_DO => RAM_DO,
+		RAM_REQUEST => RAM_REQUEST,
+		RAM_REQUEST_COMPLETE => RAM_REQUEST_COMPLETE,
+		RAM_WRITE_ENABLE => RAM_WRITE_ENABLE,
+		
+		ROM_ADDR => ROM_ADDR,
+		ROM_DO => ROM_DO,
+		ROM_REQUEST => ROM_REQUEST,
+		ROM_REQUEST_COMPLETE => ROM_REQUEST_COMPLETE,
+
+		DMA_FETCH => '0',
+		DMA_READ_ENABLE => '0',
+		DMA_32BIT_WRITE_ENABLE => '0',
+		DMA_16BIT_WRITE_ENABLE => '0',
+		DMA_8BIT_WRITE_ENABLE => '0',
+		DMA_ADDR => (others=>'0'),
+		DMA_WRITE_DATA => (others=>'0'),
+		MEMORY_READY_DMA => open,
+
+		RAM_SELECT => (others=>'0'),
+		ROM_SELECT => (others=>'0'),
+		CART_EMULATION_SELECT => "0000000",
+		CART_EMULATION_ACTIVATE => '0',
+		PAL => '1',
+		USE_SDRAM => '0',
+		ROM_IN_RAM => '0',
+		THROTTLE_COUNT_6502 => THROTTLE_COUNT_6502,
+		HALT => '0' 
+	);
+
+END vhdl;
Index: de1/build.sh
===================================================================
--- de1/build.sh	(nonexistent)
+++ de1/build.sh	(revision 24)
@@ -0,0 +1,21 @@
+rm -rf build
+mkdir build
+cp atari800core_de1.vhd build
+cp pll.* build
+cp atari800core.sdc build
+cp hexdecoder.vhd build
+cp i2c_loader.vhd build
+cp i2sslave.vhdl build
+cp sram.vhdl build
+cp sync_switches.vhd build
+
+mkdir build/common
+mkdir build/common/a8core
+mkdir build/common/components
+cp ../common/a8core/* ./build/common/a8core
+cp ../common/components/* ./build/common/components
+
+cd build
+../makeqsf ../atari800core.qsf ./common/a8core ./common/components
+
+quartus_sh --flow compile atari800core

Index: de1/hexdecoder.vhd
===================================================================
--- de1/hexdecoder.vhd	(nonexistent)
+++ de1/hexdecoder.vhd	(revision 24)
@@ -0,0 +1,75 @@
+---------------------------------------------------------------------------
+-- (c) 2013 mark watson
+-- I am happy for anyone to use this for non-commercial use.
+-- If my vhdl files are used commercially or otherwise sold,
+-- please contact me for explicit permission at scrameta (gmail).
+-- This applies for source and binary form and derived works.
+---------------------------------------------------------------------------
+LIBRARY ieee;
+USE ieee.std_logic_1164.all;
+
+ENTITY hexdecoder IS
+PORT 
+( 
+	CLK : IN STD_LOGIC;
+	NUMBER : IN STD_LOGIC_VECTOR(3 DOWNTO 0);
+	DIGIT : OUT STD_LOGIC_VECTOR(6 DOWNTO 0)
+);
+END hexdecoder;
+
+ARCHITECTURE vhdl OF hexdecoder IS
+	signal numinv : STD_LOGIC_VECTOR(3 downto 0);
+	signal digit_next : std_logic_vector(6 downto 0);
+	signal digit_reg : STD_LOGIC_VECTOR(6 DOWNTO 0);
+BEGIN
+	--numinv <= not(NUMBER);
+	numinv <= NUMBER;
+	process(numinv)
+	begin
+		case numinv is
+			when "0000" =>
+				digit_next <= "1111111";
+			when "0001" =>
+				digit_next <= "1111001";
+			when "0010" =>
+				digit_next <= "0100100";
+			when "0011" =>
+				digit_next <= "0110000";
+			when "0100" =>
+				digit_next <= "0011001";
+			when "0101" =>
+				digit_next <= "0010010";
+			when "0110" =>
+				digit_next <= "0000010";
+			when "0111" =>
+				digit_next <= "1111000";
+			when "1000" =>
+				digit_next <= "0000000";
+			when "1001" =>
+				digit_next <= "0011000";
+			when "1010" =>
+				digit_next <= "0001000";
+			when "1011" =>
+				digit_next <= "0000011";
+			when "1100" =>
+				digit_next <= "1000110";
+			when "1101" =>
+				digit_next <= "0100001";
+			when "1110" =>
+				digit_next <= "0000110";
+			when "1111" =>
+				digit_next <= "0001110";
+			when others =>
+				digit_next <= "1111111";
+		end case;
+	end process;
+	
+	process(clk)
+	begin
+		if (clk'event and clk='1') then
+			digit_reg <= digit_next;
+		end if;
+	end process;
+	
+	digit<=digit_reg;
+END vhdl;
\ No newline at end of file
Index: de1/makeqsf
===================================================================
--- de1/makeqsf	(nonexistent)
+++ de1/makeqsf	(revision 24)
@@ -0,0 +1,33 @@
+#!/usr/bin/perl -w
+use strict;
+
+my $qsf_in = shift @ARGV;
+my $qsf_out = $qsf_in;
+$qsf_out =~ s/.*\///;
+
+open (QSF_IN,$qsf_in) or die "Failed to open $qsf_in";
+my @qsf_base = <QSF_IN>;
+close (QSF_IN);
+
+open (QSF_OUT,">$qsf_out") or die "Failed to open $qsf_out";
+print QSF_OUT @qsf_base;
+
+foreach (@ARGV)
+{
+	my @vhdl = glob ("$_/*.vhd");
+	push @vhdl, glob ("$_/*.vhdl");
+	my @verilog = glob ("$_/*.v");
+
+	foreach (@verilog)
+	{
+		print QSF_OUT "set_global_assignment -name VERILOG_FILE $_\n";
+	}
+
+	foreach (@vhdl)
+	{
+		print QSF_OUT "set_global_assignment -name VHDL_FILE $_\n";
+	}
+}
+
+close (QSF_OUT);
+

Index: de1/sync_switches.vhd
===================================================================
--- de1/sync_switches.vhd	(nonexistent)
+++ de1/sync_switches.vhd	(revision 24)
@@ -0,0 +1,69 @@
+---------------------------------------------------------------------------
+-- (c) 2013 mark watson
+-- I am happy for anyone to use this for non-commercial use.
+-- If my vhdl files are used commercially or otherwise sold,
+-- please contact me for explicit permission at scrameta (gmail).
+-- This applies for source and binary form and derived works.
+---------------------------------------------------------------------------
+LIBRARY ieee;
+USE ieee.std_logic_1164.all;
+ENTITY sync_switches IS
+PORT ( 
+	CLK : IN STD_LOGIC;
+
+	SW : IN STD_LOGIC_VECTOR(9 DOWNTO 0);
+	KEY : IN STD_LOGIC_VECTOR(3 downto 0);
+	
+	SYNC_KEYS : out std_logic_vector(3 downto 0);
+	SYNC_SWITCHES : out std_logic_vector(9 downto 0)
+); 
+END sync_switches;
+
+ARCHITECTURE Behavior OF sync_switches IS
+	component synchronizer IS
+	PORT 
+	( 
+		CLK : IN STD_LOGIC;
+		RAW : IN STD_LOGIC;
+		SYNC : OUT STD_LOGIC
+	);
+	END component;
+		
+	signal sw_reg : std_logic_vector(9 downto 0);
+	signal key_reg : std_logic_vector(3 downto 0);
+	
+BEGIN
+	sw9_synchronizer : synchronizer
+		port map (clk=>clk, raw=>sw(9), sync=>sw_reg(9));	
+	sw8_synchronizer : synchronizer
+		port map (clk=>clk, raw=>sw(8), sync=>sw_reg(8));	
+	sw7_synchronizer : synchronizer
+		port map (clk=>clk, raw=>sw(7), sync=>sw_reg(7));	
+	sw6_synchronizer : synchronizer
+		port map (clk=>clk, raw=>sw(6), sync=>sw_reg(6));	
+	sw5_synchronizer : synchronizer
+		port map (clk=>clk, raw=>sw(5), sync=>sw_reg(5));			
+	sw4_synchronizer : synchronizer
+		port map (clk=>clk, raw=>sw(4), sync=>sw_reg(4));	
+	sw3_synchronizer : synchronizer
+		port map (clk=>clk, raw=>sw(3), sync=>sw_reg(3));	
+	sw2_synchronizer : synchronizer
+		port map (clk=>clk, raw=>sw(2), sync=>sw_reg(2));	
+	sw1_synchronizer : synchronizer
+		port map (clk=>clk, raw=>sw(1), sync=>sw_reg(1));	
+	sw0_synchronizer : synchronizer
+		port map (clk=>clk, raw=>sw(0), sync=>sw_reg(0));			
+
+	key3_synchronizer : synchronizer
+		port map (clk=>clk, raw=>not(key(3)), sync=>key_reg(3));	
+	key2_synchronizer : synchronizer
+		port map (clk=>clk, raw=>not(key(2)), sync=>key_reg(2));	
+	key1_synchronizer : synchronizer
+		port map (clk=>clk, raw=>not(key(1)), sync=>key_reg(1));	
+	key0_synchronizer : synchronizer
+		port map (clk=>clk, raw=>not(key(0)), sync=>key_reg(0));			
+	
+	-- outputs
+	SYNC_KEYS <= key_reg(3)&key_reg(2)&key_reg(1)&key_reg(0);
+	SYNC_SWITCHES <= sw_reg(9)&sw_reg(8)&sw_reg(7)&sw_reg(6)&sw_reg(5)&sw_reg(4)&sw_reg(3)&sw_reg(2)&sw_reg(1)&sw_reg(0);
+END Behavior;
